=begin

ѥ饰դϻ٥ϸФ٥Ѳ롣
ƥȶΥѥ饰դϹԲ˻ȤϸФ٥Ѳ

վƱ͡Ф٥롢ͥȥ٥˱ơѲ
ֹĤվ񥵥ݡ


Фϡվ + Ф٥
1 ϥڡѹȥͤ

Ϥ٤̵(wikiname/link)

ѥƥȤեȤǰ(?)

Ĵ1٥ϼΡ2٥ϥܡ

ʿݡ

ץ饰ƤӽФ
{{sps_eval()}}ϡȤ򤽤Τޤ޽Ϥ


ϥե뤫ǰͤ

$Id: hiki2lua.rb,v 1.3 2004/05/01 02:42:37 zinnia Exp $

=end
$KCODE = 'e'

require 'parser.rb'
$use_plugin = true

class LUAFormatter
  MAP = Hash::new
  def initialize(t)
    @tokens = t
  end
  def dump
    result = ''

    @tokens.each do |token|
      result += "#{token[:e]}: #{token[:s]}\n"
    end
    return result
  end
  def to_s
    result = "sps_include(\"default.lua\")\n"
    string = ''
    pageno = 0
    headinglevel = 0
    hmargin = [2, 5, 8, 11, 14]
    vmargin = [3, 2, 2, 1, 1]
    headtag = ['', '', '', '', '']
    nowpre = false

    @tokens.each do |token|
      if (nowpre && token[:e] != :pre)
        result += "sps_moveto(0, 2)\n"
        nowpre = false
      end
      case token[:e]
      when :pre
        result += %Q(sps_beginline("left")\n)
        result += %Q(sps_fontstyle(3,"i")\n)
        result += %Q(sps_puttext("#{token[:s].to_s}", 3)\n)
        result += %Q(sps_fontstyle(3,"")\n)
        result += %Q(sps_endline()\n)
        nowpre = true
        string = ''
      when :normal_text, :wikiname, :reference
        string += token[:s].to_s
      when :p_open
        result += "sps_beginline()\n" # XXX align
        string = ''
      when :p_close
        result += "sps_puttext(\"#{string}\", #{headinglevel})\n" + 
          "sps_endline()\n" +
          "sps_moveto(0, #{vmargin[headinglevel]})\n"
      when :heading1_open
        if pageno > 0 then
          result += "sps_endpage()\n"
        end
        string = ''
        pageno += 1
      when :heading1_close
        result += "sps_beginpage(\"#{string}\")\n" +
          "sps_beginline()\n" +
          "sps_puttext(\"#{string}\", 0)\n" + 
          "sps_endline()\n" +
          "sps_moveto(0, 1)\n" +
          "sps_puthbar(1)\n" + 
          "sps_hmargin(#{hmargin[0]})\n" +
          "sps_moveto(0, #{vmargin[headinglevel]})\n"
        headinglevel = 1
      when :heading2_open
        headinglevel = 2
        string = ''
      when :heading3_open
        headinglevel = 3
        string = ''
      when :ordered_list_open
      when :unordered_list_open
      when :listitem_open
        string = ''
      when :listitem_close
        result += "sps_beginline()\n" +
          "sps_puttext(\"#{string}\", #{headinglevel})\n" +
          "sps_endline()\n" +
          "sps_moveto(0, #{vmargin[headinglevel]})\n"
      when :heading2_close, :heading3_close
        result +=
          "sps_moveto(0, #{vmargin[headinglevel - 1]})\n" + 
          "sps_hmargin(#{hmargin[headinglevel - 1]})\n" +
          "sps_beginline()\n" +
          "sps_puttext(\"#{headtag[headinglevel - 2]}#{string}\", #{headinglevel - 1})\n" +
          "sps_endline()\n" + 
          "sps_moveto(0, #{vmargin[headinglevel]})\n" +
          "sps_hmargin(#{hmargin[headinglevel - 1]})\n"
      when :plugin
        case token[:method]
          #	when 'sps_eval'
          #	  result += token[:param] + "\n"
        when 'sps_bold'
          result += %Q(sps_fontstyle(1,"u")\n)
          result += %Q(sps_fontstyle(2,"u")\n)
          result += %Q(sps_fontstyle(3,"u")\n)
          result += %Q(sps_fontstyle(4,"u")\n)
          result += %Q(sps_fontstyle(5,"u")\n)
        when 'sps_normal'
          result += %Q(sps_fontstyle(1,"")\n)
          result += %Q(sps_fontstyle(2,"")\n)
          result += %Q(sps_fontstyle(3,"")\n)
          result += %Q(sps_fontstyle(4,"")\n)
          result += %Q(sps_fontstyle(5,"")\n)
        when 'sps_include'
          result += "sps_include(\"#{token[:param]}\")\n"
        when 'sps_moveto'
          result += "sps_moveto(#{token[:param]})\n"
        when 'sps_pause'
          result += "sps_pause()\n"
        when 'sps_flip_function'
          result += "sps_flip_function(\"#{token[:param]}\")\n"
        when 'sps_right'
          result +=
            "sps_beginline(\"right\")\n" +
            "sps_puttext(\"#{token[:param]}\", 4)\n" +
            "sps_endline()\n"
        end
      end
    end
    if result != '' then
      result += "sps_endpage()\n"
    end
    return result
  end
end

path = ARGV.shift
dump = ARGV.shift
if path != nil then
  open(path) do |p|
    parser = Hiki::Parser.new()

    tokens = parser.parse(p.readlines)
    lf = LUAFormatter.new(tokens)
    if dump != nil then
      print lf.dump
    else
      print "-- Auto generated by hiki2lua.rb\n" + lf.to_s
    end
  end
else
  STDERR.print "usage: hiki2lua.rb [input] [[dump]]\n"
end

